#ifndef __BUFF_H
#define __BUFF_H

#include <pthread.h>        // thread stuff

#define BUFF_UNLIMITED -1

typedef struct
{
  pthread_mutex_t mutex;    // mutex for making this thing thread safe
  int init;                 // whether this buffer was Init()'ed
  int leng;                 // number of bytes of data presently stored in the buffer
  int size;                 // number of bytes malloc'ed for this buffer
  int maxm;                 // maxmimum size that the buffer is allowed to grow to
  void * data;              // the buffer itself, in all its glory
} buff_t;

buff_t * buff_Create ();
void buff_Init (buff_t *, int max);
void buff_ClearAll (buff_t *);
int buff_Append (buff_t *, void * data, int leng);
int buff_Remaining (buff_t *);
int buff_ReadLine (buff_t *);
int buff_IndexOf (buff_t *, char * str, int strlen, int offs);
int buff_Substring (buff_t *, char * dest, int offs, int leng);
void buff_Destroy (buff_t *);

#endif /* __BUFF_H */
