#include <sys/param.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <stdio.h>

#include "inet.h"

static const char *
inet_ntop4 (src, dst, size)
  const u_char * src;
  char * dst;
  size_t size;
{
  sprintf(dst, "%u.%u.%u.%u", src[0], src[1], src[2], src[3]);
  
	return dst;
}

const char *
inet_ntop (af, src, dst, size)
	int af;
	const void * src;
	char * dst;
	size_t size;
{
	switch (af)
  {
    case AF_INET:
      return inet_ntop4(src, dst, size);
    default:
      return NULL;
	}
}
