#ifndef __ICAST_H
#define __ICAST_H

/*
 *  iCast.h
 *  iCast
 *
 *  Created by Curtis Jones on Wed Jan 21 2004.
 *  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
 *
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <pthread.h>

#ifdef __cplusplus
    extern "C" {
#endif

// udp port: 5353
// multicast ip: 224.0.0.251
// mDNS = Multicast DNS
// all mDNS names end in ".local"

#define DAAP_TYPE_BYTE    0x0001
#define DAAP_TYPE_SHORT   0x0003
#define DAAP_TYPE_INT     0x0005
#define DAAP_TYPE_LONG    0x0007
#define DAAP_TYPE_STRING  0x0009
#define DAAP_TYPE_DATE    0x000A
#define DAAP_TYPE_VERSION 0x000B
#define DAAP_TYPE_LIST    0x000C
      
struct Http_struct
{
  char file_path[1000];
  char cgi_query[1000];
  char * http_reply;
};
typedef struct Http_struct Http;
      
struct Conn_struct
{
  int                 sock;
  pthread_t           thread;
  struct sockaddr_in  addr;
  int                 addrlen;
  char              * readbuf;        // read buffer for http requests
  int                 buflen;         // bytes of data in read buffer
  int                 bufmax;         // malloc'ed size of read buffer
  Http              * http;           // current http request data
};
typedef struct Conn_struct Conn;

#ifdef __cplusplus
    }
#endif

#endif /* __ICAST_H */
